package main

/*****************************************************************************
 * Font Spec for 14 Segment Display
 *
 *      Author:  Steve <steve@floating.io>
 *        Date:  Mar 13 2023
 *
 *     License:  Freeware.  Or something.  Public domain, in any event.
 *
 * Description:
 *
 *   This file contains a simple specification for a font for a
 *   14-segment display.  You'll have to figure out what to do with
 *   it, but if you arrange your GPIO properly, you should be able to
 *   simply copy bytes to the appropriate GPIO port and be done with
 *   it...
 *
 *   The font assumes the following assigments for the display segments:
 *
 *      ___
 *                      A
 *     |\|/|          FPGHB
 *      - -     ==>    N J
 *     |/|\|          EMLKC
 *      ___  .          D    DP
 *
 *   You'll note that there are actually -15- segments, not 14, but
 *   it's still defined as a 14-segment display.  Go figure.  That
 *   decimal point really screws things up, doesn't it?
 *
 *   At the end of it, the font is a simple array of 16-bit integers;
 *   it's arranged as follows:
 *
 *   M                                 L
 *   S                                 S
 *   b (15)                        (0) b
 *   |                                 |
 *   - DP P N  M L K J  H G F E  D C B A
 *
 *   There is thus an array of 256 16-bit integers, each corresponding
 *   with an ASCII character, and showing what segments should be lit
 *   when that character is seen.  Pretty simple (and most will be
 *   empty characters, for now at least).
 *
 *   Want UTF-8?  Yeah, I'm not going there.  You can implement that
 *   one all by yourself...
 *
 ****************************************************************************/

var font14 []uint16 = []uint16{
	//-.PNMLKJHGFEDCBA
	0b0000000000001000, //   0
	0b0000010001000000, //   1  -- throbber start [|]
	0b0000100010000000, //   2  -- [/]
	0b0001000100000000, //   3  -- [-]
	0b0010001000000000, //   4  -- [\] [throbber end]
	0b0000000000000000, //   5
	0b0000000000000000, //   6
	0b0000000000000000, //   7
	0b0000000000000000, //   8
	0b0000000000000000, //   9

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, //  10
	0b0001000100001001, //  11
	0b0001000100001001, //  12
	0b0001000100001001, //  13
	0b0001000100001001, //  14
	0b0001000100001001, //  15
	0b0001000100001001, //  16
	0b0001000100001001, //  17
	0b0001000100001001, //  18
	0b0001000100001001, //  19

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, //  20
	0b0001000100001001, //  21
	0b0001000100001001, //  22
	0b0001000100001001, //  23
	0b0001000100001001, //  24
	0b0001000100001001, //  25
	0b0001000100001001, //  26
	0b0001000100001001, //  27
	0b0001000100001001, //  28
	0b0001000100001001, //  29

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, //  30
	0b0001000100001001, //  31
	0b0000000000000000, //  32 ( )
	0b0100000000000110, //  33 (!)
	0b0000000001000010, //  34 (")
	0b0001010101110000, //  35 (#) [needs work]
	0b0001010101101101, //  36 ($)
	0b0001110111100100, //  37 (%) [needs work]
	0b0011011000011001, //  38 (&) [needs work]
	0b0000000001000000, //  39 (')

	//-.PNMLKJHGFEDCBA
	0b0000001010000000, //  40 (() [needs work]
	0b0010100000000000, //  41 ()) [needs work]
	0b0011111111000000, //  42 (*)
	0b0001010101000000, //  43 (+)
	0b0000100000000000, //  44 (,)
	0b0001000100000000, //  45 (-)
	0b0100000000000000, //  46 (.)
	0b0000100010000000, //  47 (/)
	0b0000100010111111, //  48 (0)
	0b0000000000000110, //  49 (1)

	//-.PNMLKJHGFEDCBA
	0b0001000100011011, //  50 (2)
	0b0001000100001111, //  51 (3)
	0b0001000100100110, //  52 (4)
	0b0001000100101101, //  53 (5)
	0b0001000100111100, //  54 (6)
	0b0000000000000111, //  55 (7)
	0b0001000100111111, //  56 (8)
	0b0001000100100111, //  57 (9)
	0b0001000000000001, //  58 (:) [needs work]
	0b0000100000000001, //  59 (;) [needs work]

	//-.PNMLKJHGFEDCBA
	0b0100001010000000, //  60 (<)
	0b0001000100001000, //  61 (=)
	0b0010100000000000, //  62 (>)
	0b0100010100100011, //  63 (?) [needs work]
	0b0000000101111011, //  64 (@)
	0b0001000100110111, //  65 (A)
	0b0000010101001111, //  66 (B)
	0b0000000000111001, //  67 (C)
	0b0000010001001111, //  68 (D)
	0b0001000100111001, //  69 (E)

	//-.PNMLKJHGFEDCBA
	0b0001000000110001, //  70 (F)
	0b0000000100111101, //  71 (G)
	0b0001000100110110, //  72 (H)
	0b0000010001001001, //  73 (I)
	0b0000000000011110, //  74 (J)
	0b0001001010110000, //  75 (K)
	0b0000000000111000, //  76 (L)
	0b0010000010110110, //  77 (M)
	0b0010001000110110, //  78 (N)
	0b0000000000111111, //  79 (O)

	//-.PNMLKJHGFEDCBA
	0b0001000100110011, //  80 (P)
	0b0000001000111111, //  81 (Q)
	0b0001001100110011, //  82 (R)
	0b0001000100101101, //  83 (S)
	0b0000010001000001, //  84 (T)
	0b0000000000111110, //  85 (U)
	0b0000100010110000, //  86 (V)
	0b0000101000110110, //  87 (W)
	0b0010101010000000, //  88 (X)
	0b0010010010000000, //  89 (Y)

	//-.PNMLKJHGFEDCBA
	0b0000100010001001, //  90 (Z)
	0b0000000000111001, //  91 ([)
	0b0010001000000000, //  92 (\)
	0b0000000000001111, //  93 (])
	0b0010000000100000, //  94 (^)
	0b0000000000001000, //  95 (_)
	0b0010000000000000, //  96 (`)
	0b0001000100011111, //  97 (a)
	0b0001000100111100, //  98 (b)
	0b0001000100011000, //  99 (c)

	//-.PNMLKJHGFEDCBA
	0b0001000100011110, // 100 (d)
	0b0001000100111011, // 101 (e)
	0b0001000000110001, // 102 (f)
	0b0001000100101111, // 103 (g)
	0b0001000100110100, // 104 (h)
	0b0000010000000000, // 105 (i)
	0b0000000000001110, // 106 (j)
	0b0000011101000000, // 107 (k)
	0b0000000000000110, // 108 (l)
	0b0001010100010100, // 109 (m)

	//-.PNMLKJHGFEDCBA
	0b0000010100000100, // 110 (n)
	0b0001000100011100, // 111 (o)
	0b0001000100110011, // 112 (p)
	0b0001000100100111, // 113 (q)
	0b0001000100010000, // 114 (r)
	0b0001000100101101, // 115 (s)
	0b0000010101000000, // 116 (t)
	0b0000000000011100, // 117 (u)
	0b0000100000010000, // 118 (v)
	0b0000010000011100, // 119 (w)

	//-.PNMLKJHGFEDCBA
	0b0010101010000000, // 120 (x)
	0b0010010010000000, // 121 (y)
	0b0000100010001001, // 122 (z)
	0b0001010001000000, // 123 ({)
	0b0000010001000000, // 124 (|)
	0b0000010101000000, // 125 (})
	0b0001000100000000, // 126 (~) [needs work]
	0b0001000100001001, // 127
	0b0001000100001001, // 128
	0b0001000100001001, // 129

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 130
	0b0001000100001001, // 131
	0b0001000100001001, // 132
	0b0001000100001001, // 133
	0b0001000100001001, // 134
	0b0001000100001001, // 135
	0b0001000100001001, // 136
	0b0001000100001001, // 137
	0b0001000100001001, // 138
	0b0001000100001001, // 139

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 140
	0b0001000100001001, // 141
	0b0001000100001001, // 142
	0b0001000100001001, // 143
	0b0001000100001001, // 144
	0b0001000100001001, // 145
	0b0001000100001001, // 146
	0b0001000100001001, // 147
	0b0001000100001001, // 148
	0b0001000100001001, // 149

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 150
	0b0001000100001001, // 151
	0b0001000100001001, // 152
	0b0001000100001001, // 153
	0b0001000100001001, // 154
	0b0001000100001001, // 155
	0b0001000100001001, // 156
	0b0001000100001001, // 157
	0b0001000100001001, // 158
	0b0001000100001001, // 159

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 160
	0b0001000100001001, // 161
	0b0001000100001001, // 162
	0b0001000100001001, // 163
	0b0001000100001001, // 164
	0b0001000100001001, // 165
	0b0001000100001001, // 166
	0b0001000100001001, // 167
	0b0001000100001001, // 168
	0b0001000100001001, // 169

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 170
	0b0001000100001001, // 171
	0b0001000100001001, // 172
	0b0001000100001001, // 173
	0b0001000100001001, // 174
	0b0001000100001001, // 175
	0b0001000100001001, // 176
	0b0001000100001001, // 177
	0b0001000100001001, // 178
	0b0001000100001001, // 179

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 180
	0b0001000100001001, // 181
	0b0001000100001001, // 182
	0b0001000100001001, // 183
	0b0001000100001001, // 184
	0b0001000100001001, // 185
	0b0001000100001001, // 186
	0b0001000100001001, // 187
	0b0001000100001001, // 188
	0b0001000100001001, // 189

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 190
	0b0001000100001001, // 191
	0b0001000100001001, // 192
	0b0001000100001001, // 193
	0b0001000100001001, // 194
	0b0001000100001001, // 195
	0b0001000100001001, // 196
	0b0001000100001001, // 197
	0b0001000100001001, // 198
	0b0001000100001001, // 199

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 200
	0b0001000100001001, // 201
	0b0001000100001001, // 202
	0b0001000100001001, // 203
	0b0001000100001001, // 204
	0b0001000100001001, // 205
	0b0001000100001001, // 206
	0b0001000100001001, // 207
	0b0001000100001001, // 208
	0b0001000100001001, // 209

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 210
	0b0001000100001001, // 211
	0b0001000100001001, // 212
	0b0001000100001001, // 213
	0b0001000100001001, // 214
	0b0001000100001001, // 215
	0b0001000100001001, // 216
	0b0001000100001001, // 217
	0b0001000100001001, // 218
	0b0001000100001001, // 219

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 220
	0b0001000100001001, // 221
	0b0001000100001001, // 222
	0b0001000100001001, // 223
	0b0001000100001001, // 224
	0b0001000100001001, // 225
	0b0001000100001001, // 226
	0b0001000100001001, // 227
	0b0001000100001001, // 228
	0b0001000100001001, // 229

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 230
	0b0001000100001001, // 231
	0b0001000100001001, // 232
	0b0001000100001001, // 233
	0b0001000100001001, // 234
	0b0001000100001001, // 235
	0b0001000100001001, // 236
	0b0001000100001001, // 237
	0b0001000100001001, // 238
	0b0001000100001001, // 239

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 240
	0b0001000100001001, // 241
	0b0001000100001001, // 242
	0b0001000100001001, // 243
	0b0001000100001001, // 244
	0b0001000100001001, // 245
	0b0001000100001001, // 246
	0b0001000100001001, // 247
	0b0001000100001001, // 248
	0b0001000100001001, // 249

	//-.PNMLKJHGFEDCBA
	0b0001000100001001, // 250
	0b0001000100001001, // 251
	0b0001000100001001, // 252
	0b0001000100001001, // 253
	0b0001000100001001, // 254
	0b0001000100001001, // 255
}
